﻿CREATE TABLE dbo.[User]
(
    ID         INT          NOT NULL IDENTITY(1, 1) PRIMARY KEY
   ,UserID     NVARCHAR(50) NOT NULL
   ,[Password] NVARCHAR(50) NOT NULL
);
GO

CREATE PROCEDURE dbo.WriteUser
    @UserID   NVARCHAR(25)
   ,@Password NVARCHAR(20)
As
    INSERT INTO dbo.[User] VALUES (@UserID, @Password);
GO

CREATE PROCEDURE dbo.ListUser
AS
    SELECT
        ID
       ,UserID
       ,[Password]
    FROM dbo.[User]
    ORDER BY ID DESC;
GO

CREATE PROCEDURE dbo.ViewUser
    @ID INT
AS
    SELECT
        ID
       ,UserID
       ,[Password]
    From  dbo.[User]
    WHERE ID = @ID;
GO

CREATE PROCEDURE dbo.UpdateUser
    @UserID   NVARCHAR(50)
   ,@Password NVARCHAR(50)
   ,@ID       INT
AS
    BEGIN TRANSACTION;

    UPDATE dbo.[User]
    SET
        UserID     = @UserID,
        [Password] = @Password
    WHERE ID = @ID;

    COMMIT TRANSACTION;
GO

CREATE PROCEDURE dbo.DeleteUser
    @ID INT
AS
    DELETE dbo.[User] WHERE ID = @ID;
GO

CREATE PROCEDURE dbo.SearchUser
    @SearchField NVARCHAR(100)
   ,@SearchQuery NVARCHAR(100)
AS
    DECLARE @SQL NVARCHAR(1000)

    SET @SQL = '
SELECT *
FROM   dbo.[User]
WHERE ' + @SearchField + ' LIKE ''%' + @SearchQuery + '%''
'
    EXECUTE SP_EXECUTESQL @SQL;
GO