﻿using System;
using System.Web.Security;
using System.Web.UI;

namespace TestProject
{
    /// <summary>
    /// 로그인 페이지
    /// </summary>
    public partial class LoginPage : Page
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 페이지 로드시 처리하기 - Page_Load(sender, e)

        /// <summary>
        /// 페이지 로드시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        protected void Page_Load(object sender, EventArgs e)
        {
        }

        #endregion
        #region 로그인 버튼 클릭시 처리하기 - loginButton_Click(sender, e)

        /// <summary>
        /// 로그인 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        protected void loginButton_Click(object sender, EventArgs e)
        {
            UserRepository repository = new UserRepository();

            string userID   = this.userIDTextBox.Text.Trim();
            string password = this.passwordTextBox.Text.Trim();

            if(repository.IsValidUser(userID, password))
            {
                if(!string.IsNullOrEmpty(Request.QueryString["ReturnUrl"]))
                {
                    FormsAuthentication.RedirectFromLoginPage(userID, false);
                }
                else
                {
                    FormsAuthentication.SetAuthCookie(userID, false); 

                    Response.Redirect("~/WelcomePage.aspx");
                }
            }
            else
            {
                Page.ClientScript.RegisterStartupScript
                (
                    this.GetType(),
                    "loginButton_Click", 
                    "<script>alert('잘못된 사용자입니다.');</script>"
                );
            }
        }

        #endregion
    }
}