﻿using System;
using System.Web.UI;

using TestProject.Models;

namespace TestProject
{
    /// <summary>
    /// 사용자 페이지
    /// </summary>
    public partial class UserPage : Page
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 페이지 로드시 처리하기 - Page_Load(sender, e)

        /// <summary>
        /// 페이지 로드시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        protected void Page_Load(object sender, EventArgs e)
        {
            if(!Page.User.Identity.IsAuthenticated)
            {
                Response.Redirect("~/LoginPage.aspx");
            }

            if(!Page.IsPostBack)
            {
                DisplayData();
            }
        }

        #endregion
        #region 수정 버튼 클릭시 처리하기 - updateButton_Click(sender, e)

        /// <summary>
        /// 수정 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        protected void updateButton_Click(object sender, EventArgs e)
        {
            UserRepository repository = new UserRepository();

            repository.UpdateUser(Convert.ToInt32(this.idLabel.Text), this.userIDTextBox.Text.Trim(), this.passwordTextBox.Text.Trim());

            string script = "<script>alert('수정 완료');location.href='MainPage.aspx';</script>";

            Page.ClientScript.RegisterClientScriptBlock(this.GetType(), "updateButton_Click", script);
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 데이터 표시하기 - DisplayData()

        /// <summary>
        /// 데이터 표시하기
        /// </summary>
        private void DisplayData()
        {
            UserRepository repository = new UserRepository();

            UserModel user = repository.GetUser(Page.User.Identity.Name);

            this.idLabel.Text         = user.ID.ToString();
            this.userIDTextBox.Text   = user.UserID;
            this.passwordTextBox.Text = user.Password; 
        }

        #endregion
    }
}